diff --git a/gdb/breakpoint.c b/gdb/breakpoint.c
index d54d4969726..e33f1eaf02c 100644
--- a/gdb/breakpoint.c
+++ b/gdb/breakpoint.c
@@ -4320,7 +4320,7 @@ bpstat_num (bpstat *bsp, int *num)
 /* See breakpoint.h.  */
 
 void
-bpstat_clear_actions (void)
+scoped_bpstat_clear_actions::do_bpstat_clear_actions (void)
 {
   bpstat bs;
 
@@ -4473,7 +4473,7 @@ get_bpstat_thread ()
 void
 bpstat_do_actions (void)
 {
-  struct cleanup *cleanup_if_error = make_bpstat_clear_actions_cleanup ();
+  scoped_bpstat_clear_actions bpstat_clear_actions;
   thread_info *tp;
 
   /* Do any commands attached to breakpoint we are stopped at.  */
@@ -4487,7 +4487,7 @@ bpstat_do_actions (void)
 	break;
     }
 
-  discard_cleanups (cleanup_if_error);
+  bpstat_clear_actions.release ();
 }
 
 /* Print out the (old or new) value associated with a watchpoint.  */
diff --git a/gdb/breakpoint.h b/gdb/breakpoint.h
index 97b6f3fbc64..d3a55e58a4a 100644
--- a/gdb/breakpoint.h
+++ b/gdb/breakpoint.h
@@ -1682,4 +1682,37 @@ extern void print_breakpoint (breakpoint *bp);
 /* Command element for the 'commands' command.  */
 extern cmd_list_element *commands_cmd_element;
 
+/* Create an instance of this class in order to clear bpstat actions if an
+   exception is thrown.  Call the RELEASE member function in the clean
+   return case.  */
+
+class scoped_bpstat_clear_actions
+{
+public:
+  scoped_bpstat_clear_actions ()
+  { /* Nothing.  */ }
+
+  /* Destructor.  Clears partial bpstat actions if an exception occurs.  */
+  ~scoped_bpstat_clear_actions ()
+  {
+    if (!m_released)
+      do_bpstat_clear_actions ();
+  }
+
+  /* Called once the clearing is no longer needed.  */
+  void release ()
+  {
+    m_released = true;
+  }
+
+  DISABLE_COPY_AND_ASSIGN (scoped_bpstat_clear_actions);
+
+private:
+  /* Set true when the clear is no longer needed.  */
+  bool m_released = false;
+
+  /* Worker function that does the actual clear, called from destructor.  */
+  void do_bpstat_clear_actions ();
+};
+
 #endif /* !defined (BREAKPOINT_H) */
diff --git a/gdb/infrun.c b/gdb/infrun.c
index 150288264f4..ac1322dd6be 100644
--- a/gdb/infrun.c
+++ b/gdb/infrun.c
@@ -3758,9 +3758,10 @@ fetch_inferior_event (void *client_data)
 
   /* Get executed before make_cleanup_restore_current_thread above to apply
      still for the thread which has thrown the exception.  */
-  struct cleanup *ts_old_chain = make_bpstat_clear_actions_cleanup ();
+  scoped_bpstat_clear_actions bpstat_clear_actions;
 
-  make_cleanup (delete_just_stopped_threads_infrun_breakpoints_cleanup, NULL);
+  struct cleanup *ts_old_chain
+    = make_cleanup (delete_just_stopped_threads_infrun_breakpoints_cleanup, NULL);
 
   /* Now figure out what to do with the result of the result.  */
   handle_inferior_event (ecs);
@@ -3813,6 +3814,7 @@ fetch_inferior_event (void *client_data)
 	}
     }
 
+  bpstat_clear_actions.release ();
   discard_cleanups (ts_old_chain);
 
   /* No error, don't finish the thread states yet.  */
diff --git a/gdb/top.c b/gdb/top.c
index 900e78aaec5..e7b986d0598 100644
--- a/gdb/top.c
+++ b/gdb/top.c
@@ -539,12 +539,11 @@ set_repeat_arguments (const char *args)
 void
 execute_command (const char *p, int from_tty)
 {
-  struct cleanup *cleanup_if_error;
   struct cmd_list_element *c;
   const char *line;
   const char *cmd_start = p;
 
-  cleanup_if_error = make_bpstat_clear_actions_cleanup ();
+  scoped_bpstat_clear_actions bpstat_clear_actions;
   scoped_value_mark cleanup = prepare_execute_command ();
 
   /* Force cleanup of any alloca areas if using C alloca instead of
@@ -554,7 +553,7 @@ execute_command (const char *p, int from_tty)
   /* This can happen when command_line_input hits end of file.  */
   if (p == NULL)
     {
-      discard_cleanups (cleanup_if_error);
+      bpstat_clear_actions.release ();
       return;
     }
 
@@ -649,7 +648,7 @@ execute_command (const char *p, int from_tty)
   if (has_stack_frames () && inferior_thread ()->state != THREAD_RUNNING)
     check_frame_language_change ();
 
-  discard_cleanups (cleanup_if_error);
+  bpstat_clear_actions.release ();
 }
 
 /* Run execute_command for P and FROM_TTY.  Capture its output into the
diff --git a/gdb/utils.c b/gdb/utils.c
index ed8d60fa7b0..4af75e34809 100644
--- a/gdb/utils.c
+++ b/gdb/utils.c
@@ -3057,23 +3057,6 @@ parse_pid_to_attach (const char *args)
   return pid;
 }
 
-/* Helper for make_bpstat_clear_actions_cleanup.  */
-
-static void
-do_bpstat_clear_actions_cleanup (void *unused)
-{
-  bpstat_clear_actions ();
-}
-
-/* Call bpstat_clear_actions for the case an exception is throw.  You should
-   discard_cleanups if no exception is caught.  */
-
-struct cleanup *
-make_bpstat_clear_actions_cleanup (void)
-{
-  return make_cleanup (do_bpstat_clear_actions_cleanup, NULL);
-}
-
 /* Substitute all occurences of string FROM by string TO in *STRINGP.  *STRINGP
    must come from xrealloc-compatible allocator and it may be updated.  FROM
    needs to be delimited by IS_DIR_SEPARATOR or DIRNAME_SEPARATOR (or be
diff --git a/gdb/utils.h b/gdb/utils.h
index f2fe1da832c..896feb973c9 100644
--- a/gdb/utils.h
+++ b/gdb/utils.h
@@ -286,7 +286,6 @@ private:
   int m_save_batch_flag;
 };
 
-extern struct cleanup *make_bpstat_clear_actions_cleanup (void);
 
 /* Path utilities.  */
 